library colorfilter_generator;

import 'package:flutter/material.dart';

///The [ColorFilterGenerator] class to define a Filter which will applied to each color, consists of multiple [SubFilter]s
class ColorFilterGenerator {
  String name;
  List<List<double>> subFilters;
  ColorFilterGenerator({required this.name}) : subFilters = [];

  Widget apply(Widget child) {
    Widget tree = child;

    for (int i = 0; i < subFilters.length; i++) {
      tree = ColorFiltered(
        colorFilter: ColorFilter.matrix(subFilters[i]),
        child: tree,
      );
    }

    return tree;
  }

  void addSubFilter(List<double> subFilter) {
    subFilters.add(subFilter);
  }

  void addSubFilters(List<List<double>> subFilters) {
    this.subFilters.addAll(subFilters);
  }
}
